function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState } from "react";
var imgStyle = {
  transition: "transform .3s cubic-bezier(0.0,0.0,0.2,1),opacity linear .5s"
};
var selectedImgStyle = {
  transform: "translateZ(0px) scale3d(0.9, 0.9, 1)",
  transition: "transform .3s cubic-bezier(0.0,0.0,0.2,1),opacity linear .5s"
};

var PhotoItem = function PhotoItem(props) {
  var photo = props.photo,
      onRemove = props.onRemove,
      index = props.index,
      top = props.top,
      left = props.left,
      isColumn = props.isColumn;

  var _useState = useState(false),
      isHovered = _useState[0],
      setIsHovered = _useState[1];

  var _onMouseEnter = function _onMouseEnter() {
    return setIsHovered(true);
  };

  var _onMouseLeave = function _onMouseLeave() {
    return setIsHovered(false);
  };

  var _onRemove = function _onRemove() {
    return onRemove(index);
  };

  var width = photo.width,
      height = photo.height,
      src = photo.src,
      name = photo.name;
  var sx = (100 - 10 / width * 100) / 100;
  var sy = (100 - 10 / height * 100) / 100;
  selectedImgStyle.transform = "translateZ(0px) scale3d(" + sx + ", " + sy + ", 1)";
  return /*#__PURE__*/React.createElement("div", {
    className: "img-wrap",
    style: {
      height: height,
      width: width,
      top: top,
      left: left,
      position: isColumn ? "absolute" : "relative"
    },
    onMouseEnter: _onMouseEnter,
    onMouseLeave: _onMouseLeave
  }, /*#__PURE__*/React.createElement("img", {
    alt: name,
    src: src,
    style: isHovered ? _extends({}, imgStyle, selectedImgStyle) : imgStyle,
    width: isHovered ? width - 4 : width,
    height: isHovered ? height - 4 : height
  }), isHovered && /*#__PURE__*/React.createElement("span", {
    onClick: _onRemove,
    className: "ic-close"
  }, "\xD7"));
};

export default PhotoItem;