"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _builder = _interopRequireDefault(require("./../../components/hyperformula/builder"));

var _agGridTable = _interopRequireDefault(require("./ag-grid-table"));

var _reactBootstrap = require("react-bootstrap");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactFormulaField = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ReactFormulaField, _React$Component);

  function ReactFormulaField(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (values) {
      var onChange = _this.props.onChange;
      onChange && onChange(values);
    });

    _this.builder = new _builder["default"]();
    _this.state = {
      headers: []
    };
    return _this;
  }

  var _proto = ReactFormulaField.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var headers = this.getHeaders(this.props);
    this.builder.withHeaders(headers);
    this.setState({
      headers: headers
    });
  };

  _proto.getHeaders = function getHeaders() {
    var _this2 = this;

    var properties = _lodash["default"].get(this.props, "schema.items.properties", {});

    var headers = _lodash["default"].toPairs(properties);

    return _lodash["default"].map(headers, function (_ref) {
      var headerKey = _ref[0],
          headerObject = _ref[1];

      var header = _extends({
        header: headerKey
      }, headerObject);

      if (header.readOnly) {
        var formula = _lodash["default"].get(_this2.props, "uiSchema.ui:options.formulas." + headerKey, "");

        header.formula = formula;
      }

      return header;
    });
  };

  _proto.render = function render() {
    this.builder.withDataObjects(this.props.formData);

    var label = _lodash["default"].get(this.props, "schema.title", "");

    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, label)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, this.builder && /*#__PURE__*/_react["default"].createElement(_agGridTable["default"], {
      builder: this.builder,
      headers: this.state.headers,
      value: this.props.formData,
      onChange: this.handleChange,
      confirmRemove: this.props.uiSchema["ui:options"].confirmRemove || false,
      removable: this.props.uiSchema["ui:options"].removable === undefined ? true : this.props.uiSchema["ui:options"].removable,
      height: this.props.uiSchema["ui:options"].height,
      width: this.props.uiSchema["ui:options"].width
    }))));
  };

  return ReactFormulaField;
}(_react["default"].Component);

var _default = ReactFormulaField;
exports["default"] = _default;
module.exports = exports.default;