"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var imgStyle = {
  transition: "transform .3s cubic-bezier(0.0,0.0,0.2,1),opacity linear .5s"
};
var selectedImgStyle = {
  transform: "translateZ(0px) scale3d(0.9, 0.9, 1)",
  transition: "transform .3s cubic-bezier(0.0,0.0,0.2,1),opacity linear .5s"
};

var PhotoItem = function PhotoItem(props) {
  var photo = props.photo,
      onRemove = props.onRemove,
      index = props.index,
      top = props.top,
      left = props.left,
      isColumn = props.isColumn;

  var _useState = (0, _react.useState)(false),
      isHovered = _useState[0],
      setIsHovered = _useState[1];

  var _onMouseEnter = function _onMouseEnter() {
    return setIsHovered(true);
  };

  var _onMouseLeave = function _onMouseLeave() {
    return setIsHovered(false);
  };

  var _onRemove = function _onRemove() {
    return onRemove(index);
  };

  var width = photo.width,
      height = photo.height,
      src = photo.src,
      name = photo.name;
  var sx = (100 - 10 / width * 100) / 100;
  var sy = (100 - 10 / height * 100) / 100;
  selectedImgStyle.transform = "translateZ(0px) scale3d(" + sx + ", " + sy + ", 1)";
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "img-wrap",
    style: {
      height: height,
      width: width,
      top: top,
      left: left,
      position: isColumn ? "absolute" : "relative"
    },
    onMouseEnter: _onMouseEnter,
    onMouseLeave: _onMouseLeave
  }, /*#__PURE__*/_react["default"].createElement("img", {
    alt: name,
    src: src,
    style: isHovered ? _extends({}, imgStyle, selectedImgStyle) : imgStyle,
    width: isHovered ? width - 4 : width,
    height: isHovered ? height - 4 : height
  }), isHovered && /*#__PURE__*/_react["default"].createElement("span", {
    onClick: _onRemove,
    className: "ic-close"
  }, "\xD7"));
};

var _default = PhotoItem;
exports["default"] = _default;
module.exports = exports.default;