"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _axios = _interopRequireDefault(require("axios"));

var _reactBootstrap = require("react-bootstrap");

var _reactPhotoGallery = _interopRequireDefault(require("react-photo-gallery"));

var _index = require("../../index");

var _PhotoItem = _interopRequireDefault(require("./components/PhotoItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactPhotoGalleryField = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ReactPhotoGalleryField, _React$Component);

  function ReactPhotoGalleryField() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleRemoveFile", function (index) {
      var _this$props = _this.props,
          formData = _this$props.formData,
          onChange = _this$props.onChange;

      var newFormData = _.reject(formData || [], function (item, i) {
        return i === index;
      });

      onChange && onChange(newFormData);
    });

    _defineProperty(_assertThisInitialized(_this), "handleAcceptFiles", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(acceptedFiles) {
        var onChange, _ref2, fileUploadUrl, authenticityToken, formData, response, responseData, attachments, newAttachments;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                onChange = _this.props.onChange;
                _ref2 = _.get(_this.props, "options") || {}, fileUploadUrl = _ref2.fileUploadUrl, authenticityToken = _ref2.authenticity_token;
                formData = _this.createFormData(acceptedFiles, authenticityToken);
                _context.next = 5;
                return _axios["default"].post(fileUploadUrl, formData, {
                  headers: {
                    Accept: "application/json",
                    "X-CSRF-Token": authenticityToken
                  }
                });

              case 5:
                response = _context.sent;
                responseData = _.get(response, "data");
                attachments = _this.getAttachments();

                if (_.isArray(responseData)) {
                  newAttachments = [].concat(attachments, responseData);
                  onChange && onChange(newAttachments);
                } else {
                  attachments.push(responseData);
                  onChange && onChange(attachments);
                }

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_this), "renderPhotos", function (item) {
      return /*#__PURE__*/_react["default"].createElement(_PhotoItem["default"], _extends({}, item, {
        key: item.index,
        isColumn: _this.isColumnLayout(),
        onRemove: _this.handleRemoveFile
      }));
    });

    return _this;
  }

  var _proto = ReactPhotoGalleryField.prototype;

  _proto.isDisabled = function isDisabled() {
    var _this$props2 = this.props,
        readonly = _this$props2.readonly,
        readOnly = _this$props2.readOnly,
        disabled = _this$props2.disabled;
    var isDisabled = readonly || readOnly || disabled;
    return isDisabled;
  };

  _proto.createFormData = function createFormData(acceptedFiles, authenticityToken) {
    var data = new FormData();

    for (var _iterator = _createForOfIteratorHelperLoose(acceptedFiles), _step; !(_step = _iterator()).done;) {
      var file = _step.value;
      data.append("attachments", file, file.name);
    }

    data.append("authenticity_token", authenticityToken);
    return data;
  };

  _proto.getAttachments = function getAttachments() {
    var attachments = _.get(this.props, "formData", []) || [];

    if (_.isArray(attachments)) {
      return attachments;
    } else {
      return [];
    }
  };

  _proto.isColumnLayout = function isColumnLayout() {
    return !_.isEmpty(this.getAttachments);
  };

  _proto.renderGallery = function renderGallery() {
    var renderedAttachments = _.map(this.getAttachments(), function (_ref3) {
      var url = _ref3.url;
      return {
        src: url,
        width: 1,
        height: 1
      };
    });

    return /*#__PURE__*/_react["default"].createElement(_reactPhotoGallery["default"], {
      photos: renderedAttachments,
      renderImage: this.renderPhotos,
      columns: 2,
      direction: this.isColumnLayout() ? "column" : "row"
    });
  };

  _proto.render = function render() {
    var _this$props3 = this.props,
        schema = _this$props3.schema,
        uploadComponent = _this$props3.uploadComponent;
    var UploadComponent = uploadComponent || _index.ReactDropZoneWidget;
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Group, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, schema.title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "react-gallery"
    }, !this.isDisabled() && /*#__PURE__*/_react["default"].createElement(UploadComponent, {
      title: schema.title,
      accepted: ["image/*"],
      onAcceptedFiles: this.handleAcceptFiles,
      className: "d-print-none"
    }), this.renderGallery()));
  };

  return ReactPhotoGalleryField;
}(_react["default"].Component);

var _default = ReactPhotoGalleryField;
exports["default"] = _default;
module.exports = exports.default;