"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactSignatureCanvas = _interopRequireDefault(require("react-signature-canvas"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ReactSignatureCanvasField = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactSignatureCanvasField, _Component);

  function ReactSignatureCanvasField(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = _extends({}, props, {
      width: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].width || 400,
      height: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].height || 150,
      value: props.formData || ""
    });
    return _this;
  }

  var _proto = ReactSignatureCanvasField.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (!this.state.readonly && this.sigCanvas) this.sigCanvas.fromDataURL(this.state.formData);
  };

  _proto._clear = function _clear(e) {
    e.preventDefault();
    var confirmed = confirm("Clear the signature?");

    if (confirmed) {
      this.sigCanvas.clear();
      this.setState({
        value: ""
      });
      this.state.onChange();
    } else {
      return false;
    }
  };

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        position: "relative",
        width: this.state.width + 41,
        minHeight: this.state.height + 40
      }
    }, !this.state.readonly ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactSignatureCanvas["default"], {
      ref: function ref(_ref) {
        _this2.sigCanvas = _ref;
      },
      penColor: "black",
      canvasProps: {
        width: this.state.width,
        height: this.state.height,
        className: "sigCanvas",
        style: {
          border: "#ddd 3px dashed",
          borderRadius: 4
        }
      },
      backgroundColor: "#fafafa",
      onEnd: function onEnd(value) {
        _this2.state.onChange(_this2.sigCanvas.toDataURL(value));

        _this2.setState({
          value: _this2.sigCanvas.toDataURL(value)
        });
      }
    }), /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      style: {
        border: 0,
        height: 1,
        width: 1
      },
      value: this.state.value,
      onChange: function onChange(event) {
        return _this2.state.value;
      },
      readOnly: true,
      required: this.state.required
    }), this.sigCanvas && !this.sigCanvas.isEmpty() ? /*#__PURE__*/_react["default"].createElement("button", {
      className: "btn btn-secondary d-print-none",
      style: {
        position: "absolute",
        right: 0,
        top: 0,
        height: this.state.height + 6,
        fontSize: 16,
        fontWeight: "700",
        borderTopLeftRadius: 0,
        borderBottomLeftRadius: 0,
        borderWidth: 3
      },
      onClick: this._clear.bind(this)
    }, "\xD7") : null) : this.state.formData ? /*#__PURE__*/_react["default"].createElement("img", {
      style: {
        minHeight: this.state.height
      },
      src: this.state.formData
    }) : /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        minHeight: this.state.height,
        fontWeight: "700",
        lineHeight: this.state.height + "px",
        color: "#666",
        backgroundColor: "#fafafa",
        textAlign: "center"
      }
    }, "No Signature"), /*#__PURE__*/_react["default"].createElement("div", {
      className: "sigSalutation"
    }, /*#__PURE__*/_react["default"].createElement("h6", {
      style: {
        paddingTop: 10,
        marginTop: 15,
        borderTop: "#444 1px solid"
      }
    }, this.state.schema.title)));
  };

  return ReactSignatureCanvasField;
}(_react.Component);

var _default = ReactSignatureCanvasField;
exports["default"] = _default;
module.exports = exports.default;