"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _intelligentTreeSelect = require("intelligent-tree-select");

var _lodash = _interopRequireDefault(require("lodash"));

require("intelligent-tree-select/lib/styles.css");

var _tree = _interopRequireDefault(require("../../objects/tree"));

var _option = _interopRequireDefault(require("./option"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactTreeSelectField = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactTreeSelectField, _Component);

  function ReactTreeSelectField(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleFetchChildren", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(args) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", _this.tree.getChildOptions(args.option));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (valueOptions) {
      var isMulti = _lodash["default"].get(_this.props, "uiSchema.ui:options.isMulti", false);

      if (!isMulti) {
        var value = _lodash["default"].get(valueOptions, "value");

        _this.props.onChange(value ? [value] : []);
      } else {
        var _value = valueOptions.map(function (option) {
          return option.value;
        });

        _this.props.onChange(_value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputChange", function () {});

    _this.select = _react["default"].createRef();
    _this.state = _extends({}, props, {
      width: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].width || 400,
      height: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].height || 150,
      value: props.formData || ""
    });
    var remoteOptions = _lodash["default"].get(props, "uiSchema.ui:options.remote.data") || [];
    _this.tree = new _tree["default"](remoteOptions, _this.select);
    return _this;
  }

  var _proto = ReactTreeSelectField.prototype;

  _proto.getOptionsFromValue = function getOptionsFromValue(value) {
    var currentSelect = this.select.current;

    if (currentSelect) {
      var options = currentSelect.state.options;
      var selectedOptions = (options || []).filter(function (option) {
        return (value || []).some(function (term) {
          return term === option.value;
        });
      });
      return selectedOptions;
    }
  };

  _proto.isRemote = function isRemote() {
    var remoteOptions = _lodash["default"].get(this.props, "uiSchema.ui:options.remote.data") || [];
    return remoteOptions.length > 0;
  };

  _proto.getSchemaOptions = function getSchemaOptions() {
    var uiSchema = this.props.uiSchema;

    if (this.isRemote()) {
      return _lodash["default"].get(uiSchema["ui:options"], "treeOptions");
    } else {
      return _lodash["default"].map(_lodash["default"].get(uiSchema["ui:options"], "treeOptions"), function (opt) {
        if (opt.children.length === 0) {
          opt.isEnd = true;
        }

        return opt;
      });
    }
  };

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        schema = _this$props.schema,
        formData = _this$props.formData;

    var isMulti = _lodash["default"].get(this.props, "uiSchema.ui:options.isMulti", false);

    var isCreateable = _lodash["default"].get(this.props, "uiSchema.ui:options.isCreateable", false);

    var schemaOptions = this.getSchemaOptions();
    var valueOptions = this.getOptionsFromValue(formData, schemaOptions);
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", null, schema.title), /*#__PURE__*/_react["default"].createElement(_intelligentTreeSelect.IntelligentTreeSelect, {
      optionRenderer: function optionRenderer(optionProps) {
        return /*#__PURE__*/_react["default"].createElement(_option["default"], _extends({}, optionProps, {
          select: _this2.select
        }));
      },
      ref: function ref(select) {
        _this2.select.current = select;
      },
      showSettings: isCreateable,
      multi: isMulti,
      options: schemaOptions || [],
      value: isMulti ? valueOptions : _lodash["default"].get(valueOptions, "0"),
      fetchOptions: this.handleFetchChildren,
      onChange: this.handleChange,
      onInputChange: this.handleInputChange
    }));
  };

  return ReactTreeSelectField;
}(_react.Component);

var _default = ReactTreeSelectField;
exports["default"] = _default;
module.exports = exports.default;