"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactBootstrap = require("react-bootstrap");

require("intelligent-tree-select/lib/styles.css");

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactTreeSelectFieldOption = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactTreeSelectFieldOption, _Component);

  function ReactTreeSelectFieldOption() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (event) {
      var props = _this.props;

      if (!_this.props.option.isEnd) {
        event.stopPropagation();
        return;
      }

      _this.props.selectValue(_this.props.option);

      console.log(event, props);
    });

    _defineProperty(_assertThisInitialized(_this), "handleToggle", function () {
      _this.props.focusOption(_this.props.option);

      _this.props.toggleOption(_this.props.option);

      _this.props.select.current.forceUpdate();
    });

    _defineProperty(_assertThisInitialized(_this), "isOptionSelected", function () {
      return _lodash["default"].some(_this.props.valueArray, function (selectedOption) {
        return selectedOption.value === _this.props.option.value;
      });
    });

    return _this;
  }

  var _proto = ReactTreeSelectFieldOption.prototype;

  _proto.render = function render() {
    var fetching = this.props.select.current.state.isLoadingExternally;
    var expanded = this.props.option.expanded;
    var isSelected = this.isOptionSelected();
    return /*#__PURE__*/_react["default"].createElement("li", {
      style: _extends({
        listStyleType: "none"
      }, this.props.optionStyle)
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
      style: {
        margin: "5px"
      },
      className: "align-items-center"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      xs: "auto",
      md: "auto",
      onClick: this.handleToggle,
      style: {
        padding: "0 5px",
        margin: 0
      },
      className: "btn"
    }, fetching && "" + this.props.focusedOptionIndex === "" + this.props.optionIndex && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Spinner, {
      size: "sm",
      animation: "border"
    }), !(fetching && "" + this.props.focusedOptionIndex === "" + this.props.optionIndex) && !this.props.option.isEnd && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactFontawesome["default"], {
      name: expanded ? "minus-circle" : "plus-circle"
    }))), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      xs: "auto",
      style: {
        padding: 0,
        margin: 0,
        fontWeight: isSelected ? "bold" : "normal"
      },
      className: "btn",
      onClick: this.handleClick
    }, this.props.option.label)));
  };

  return ReactTreeSelectFieldOption;
}(_react.Component);

;
var _default = ReactTreeSelectFieldOption;
exports["default"] = _default;
module.exports = exports.default;