"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var TreeOption = /*#__PURE__*/function () {
  function TreeOption(raw, isEnd) {
    _lodash["default"].merge(this, raw);

    this.isEnd = isEnd;
  }

  var _proto = TreeOption.prototype;

  _proto.withParent = function withParent(parent) {
    this.parent = parent;
    return this;
  };

  _proto.withChildren = function withChildren(children) {
    var _this$children;

    (_this$children = this.children).push.apply(_this$children, children);

    return this;
  };

  _proto.getParentValues = function getParentValues(values) {
    if (values === void 0) {
      values = [this.id];
    }

    if (this.parent) {
      var parentValue = this.parent.id;
      return this.parent.getParentValues([parentValue].concat(values));
    }

    return values;
  };

  return TreeOption;
}();

var _default = TreeOption;
exports["default"] = _default;
module.exports = exports.default;