"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _mustache = _interopRequireDefault(require("../helpers/mustache"));

var _treeOption = _interopRequireDefault(require("./tree-option"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Tree = /*#__PURE__*/function () {
  function Tree(remoteData, ref) {
    this.references = this.getSortedRemoteData(remoteData);
    this.options = [];
    this.ref = ref;
  }

  var _proto = Tree.prototype;

  _proto.getSortedRemoteData = function getSortedRemoteData(datas) {
    return datas.sort(function (left, right) {
      return _lodash["default"].get(left, "parent") - _lodash["default"].get(right, "parent");
    });
  };

  _proto.getChildOptions = /*#__PURE__*/function () {
    var _getChildOptions = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(option) {
      var _this$options, levelZeroOption, response, responseData, options, treeOptions, _this$options2, parentOption, parentValue, parentTreeOption, currentDepth, selectedReference, parentValues, derivedUrl, _options, isEnd, _treeOptions;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!_lodash["default"].isEmpty(this.references) && !option)) {
                _context.next = 13;
                break;
              }

              levelZeroOption = this.references[0];
              _context.next = 4;
              return _axios["default"].get(levelZeroOption.url);

            case 4:
              response = _context.sent;
              responseData = response.data;
              _context.next = 8;
              return this.getOptionsFromResponseData(levelZeroOption, responseData, option);

            case 8:
              options = _context.sent;

              if (option) {
                option.children = _lodash["default"].map(options, function (o) {
                  return o.value;
                });
              }

              treeOptions = _lodash["default"].map(options, function (o) {
                return new _treeOption["default"](o);
              });

              (_this$options = this.options).push.apply(_this$options, treeOptions);

              return _context.abrupt("return", options);

            case 13:
              if (!(!_lodash["default"].isEmpty(this.references) && option)) {
                _context.next = 36;
                break;
              }

              parentOption = option;
              parentValue = parentOption.value;
              parentTreeOption = _lodash["default"].find(this.options, function (o) {
                return o.value === parentValue;
              });

              if (parentTreeOption) {
                _context.next = 20;
                break;
              }

              option.children = [];
              return _context.abrupt("return", []);

            case 20:
              currentDepth = parentOption.depth + 1;
              selectedReference = this.references[currentDepth];

              if (selectedReference) {
                _context.next = 25;
                break;
              }

              parentOption.isEnd = true;
              return _context.abrupt("return", []);

            case 25:
              parentValues = parentTreeOption.getParentValues();
              derivedUrl = _mustache["default"].getCompiledText(selectedReference.url, {
                parent: parentValues
              });
              _context.next = 29;
              return this.getDerivedOptions(derivedUrl, selectedReference, parentOption);

            case 29:
              _options = _context.sent;
              isEnd = currentDepth + 1 === this.references.length;

              if (parentOption) {
                parentOption.children = _lodash["default"].map(_options, function (o) {
                  return o.value;
                });
              }

              _treeOptions = _lodash["default"].map(_options, function (o) {
                return new _treeOption["default"](o, isEnd).withParent(parentTreeOption);
              });
              parentTreeOption.withChildren(_treeOptions);

              (_this$options2 = this.options).push.apply(_this$options2, _treeOptions);

              return _context.abrupt("return", _treeOptions);

            case 36:
              return _context.abrupt("return", []);

            case 37:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function getChildOptions(_x) {
      return _getChildOptions.apply(this, arguments);
    }

    return getChildOptions;
  }();

  _proto.isParentInLastDepth = function isParentInLastDepth(parentOption) {
    if (!parentOption) {
      return false;
    }

    var maxDepth = this.references.length - 1;
    return _lodash["default"].get(parentOption, "depth", 0) + 1 >= maxDepth;
  };

  _proto.getDerivedOptions = /*#__PURE__*/function () {
    var _getDerivedOptions = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(derivedUrl, selectedReference, selectedOption) {
      var response, responseData, options;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return _axios["default"].get(derivedUrl);

            case 3:
              response = _context2.sent;
              responseData = response.data;
              options = this.getOptionsFromResponseData(selectedReference, responseData, selectedOption);
              return _context2.abrupt("return", options);

            case 9:
              _context2.prev = 9;
              _context2.t0 = _context2["catch"](0);
              return _context2.abrupt("return", []);

            case 12:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this, [[0, 9]]);
    }));

    function getDerivedOptions(_x2, _x3, _x4) {
      return _getDerivedOptions.apply(this, arguments);
    }

    return getDerivedOptions;
  }();

  _proto.getDerivedUrl = function getDerivedUrl(url, parentValue) {
    var derivedUrl = _lodash["default"].replace(url, ":id", parentValue);

    return derivedUrl;
  };

  _proto.getOptionsFromResponseData = function getOptionsFromResponseData(selectedReference, responseData, parent) {
    var records = _lodash["default"].get(responseData, selectedReference.record.join("."), []);

    var isParentInLastDepth = this.isParentInLastDepth(parent);
    return _lodash["default"].map(records, function (record) {
      var label = _lodash["default"].get(record, selectedReference.label.join("."));

      var value = _lodash["default"].get(record, selectedReference.value.join("."));

      return {
        label: label,
        id: record.id,
        value: value,
        children: isParentInLastDepth ? [] : [""],
        parent: parent ? parent.value : null,
        depth: parent ? parent.depth + 1 : 0
      };
    });
  };

  return Tree;
}();

var _default = Tree;
exports["default"] = _default;
module.exports = exports.default;