"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDatepicker = _interopRequireDefault(require("react-datepicker"));

var _lodash = _interopRequireDefault(require("lodash"));

require("react-datepicker/dist/react-datepicker.css");

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ButtonInput = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ButtonInput, _React$Component);

  function ButtonInput() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      e.preventDefault();

      _this.props.onClick(e);
    });

    return _this;
  }

  var _proto = ButtonInput.prototype;

  _proto.render = function render() {
    var value = this.props.value;
    if (value && this.props.displayFormat) value = (0, _moment["default"])(this.props.value).format(this.props.displayFormat);
    return /*#__PURE__*/_react["default"].createElement("a", {
      className: "btn btn-sm btn-secondary",
      href: "#!",
      onClick: this.handleClick
    }, value || /*#__PURE__*/_react["default"].createElement("span", {
      className: "d-print-none"
    }, "Choose Date"));
  };

  return ButtonInput;
}(_react["default"].Component);

ButtonInput.propTypes = process.env.NODE_ENV !== "production" ? {
  onClick: _propTypes["default"].func,
  value: _propTypes["default"].string
} : {};

var ReactDatePickerWidget = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactDatePickerWidget, _Component);

  function ReactDatePickerWidget(props) {
    var _this2;

    _this2 = _Component.call(this, props) || this;
    _this2.state = _extends({}, props);
    _this2.dataFormat = null;
    _this2.displayFormat = "MM/DD/YYYY";

    if (_this2.state.options && _this2.state.options.format) {
      if (typeof _this2.state.options.format === "object" && _this2.state.options.format !== null) {
        _this2.dataFormat = _this2.state.options.format.data;
        _this2.displayFormat = _this2.state.options.format.display;
      } else {
        _this2.dataFormat = _this2.state.options.format;
        _this2.displayFormat = _this2.state.options.format;
      }
    }

    return _this2;
  }

  var _proto2 = ReactDatePickerWidget.prototype;

  _proto2.render = function render() {
    var _this3 = this;

    var _$get = _lodash["default"].get(this.props, "schema", {}),
        title = _$get.title;

    var selected = null;
    if (this.state.value) selected = (0, _moment["default"])(this.state.value, this.dataFormat).toDate();
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: "block"
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactDatepicker["default"], {
      customInput: /*#__PURE__*/_react["default"].createElement(ButtonInput, {
        displayFormat: this.displayFormat
      }),
      selected: selected,
      required: this.state.required,
      onChange: function onChange(date) {
        var value = date;
        if (_this3.dataFormat) value = (0, _moment["default"])(date).format(_this3.dataFormat);

        _this3.setState({
          value: date
        }, function () {
          return _this3.state.onChange(value);
        });
      },
      strictParsing: true,
      disabled: this.state.disabled,
      readOnly: this.state.readonly,
      isClearable: true
    }), /*#__PURE__*/_react["default"].createElement("input", {
      name: this.props.id,
      id: this.props.id,
      style: {
        position: "absolute",
        border: 0,
        width: 1,
        height: 1
      },
      type: "text",
      onChange: function onChange(event) {
        return _this3.state.value;
      },
      required: this.props.required,
      value: this.state.value || ""
    })));
  };

  return ReactDatePickerWidget;
}(_react.Component);

var _default = ReactDatePickerWidget;
exports["default"] = _default;
module.exports = exports.default;