"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDropzone = _interopRequireDefault(require("react-dropzone"));

var _lodash = _interopRequireDefault(require("lodash"));

var _FileDisplay = _interopRequireDefault(require("./components/FileDisplay"));

var _reactBootstrap = require("react-bootstrap");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ReactDropZoneWidget(props) {
  var isReading = props.isReading,
      onAcceptedFiles = props.onAcceptedFiles,
      onChange = props.onChange;

  var _useState = (0, _react.useState)(false),
      saving = _useState[0],
      setSaving = _useState[1];

  var acceptedFiles = _lodash["default"].get(props, "options.accepted");

  var originalValue = _lodash["default"].isArray(props.value) ? props.value : [];

  var _onDrop = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(acceptedFiles) {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              setSaving(true);

              if (!(acceptedFiles.length > 0 && onAcceptedFiles)) {
                _context.next = 5;
                break;
              }

              _context.next = 5;
              return onAcceptedFiles([].concat(originalValue, acceptedFiles));

            case 5:
              if (!(acceptedFiles.length > 0 && onChange)) {
                _context.next = 8;
                break;
              }

              _context.next = 8;
              return onChange([].concat(originalValue, acceptedFiles));

            case 8:
              _context.next = 13;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](0);
              alert(_context.t0);

            case 13:
              _context.prev = 13;
              setSaving(false);
              return _context.finish(13);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 10, 13, 16]]);
    }));

    return function _onDrop(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var handleRemove = function handleRemove(item, index) {
    var filteredFiles = _lodash["default"].reject(props.value, function (file, currentIndex) {
      return index === currentIndex;
    });

    props.onChange && props.onChange(filteredFiles);
  };

  var areFilesVisible = _lodash["default"].get(props, "options.withFileDisplay") && !_lodash["default"].isEmpty(props.value);
  return /*#__PURE__*/_react["default"].createElement(_reactDropzone["default"], {
    onDrop: _onDrop,
    accept: acceptedFiles || ["image/*"],
    disabled: saving
  }, function (_ref2) {
    var getRootProps = _ref2.getRootProps,
        getInputProps = _ref2.getInputProps,
        isDragActive = _ref2.isDragActive;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("section", {
      className: "d-print-none"
    }, /*#__PURE__*/_react["default"].createElement("div", _extends({
      className: "dropzone " + (isDragActive ? "active" : "")
    }, getRootProps()), /*#__PURE__*/_react["default"].createElement("input", _extends({}, getInputProps(), {
      name: props.id
    })), saving ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "m-auto"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Spinner, {
      size: "sm"
    }), /*#__PURE__*/_react["default"].createElement("span", null, "Handling files... \xA0"), /*#__PURE__*/_react["default"].createElement("span", {
      className: "spinner-border spinner-border-sm text-info",
      role: "status",
      "aria-hidden": "true"
    })) : isDragActive ? /*#__PURE__*/_react["default"].createElement("p", null, "Drop here...") : /*#__PURE__*/_react["default"].createElement("p", null, "Drag and drop files here, or click to select files"))), props.rawErrors && props.rawErrors.map(function (error) {
      return /*#__PURE__*/_react["default"].createElement("div", null, error);
    }), areFilesVisible && /*#__PURE__*/_react["default"].createElement(_FileDisplay["default"], {
      files: props.value,
      onRemove: handleRemove
    }));
  });
}

var _default = ReactDropZoneWidget;
exports["default"] = _default;
module.exports = exports.default;