"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _agGridReact = require("ag-grid-react");

require("ag-grid-community/dist/styles/ag-grid.css");

require("ag-grid-community/dist/styles/ag-theme-alpine.css");

var _reactBootstrap = require("react-bootstrap");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactAgGridInputTable = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ReactAgGridInputTable, _React$Component);

  function ReactAgGridInputTable() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      isFormulaDisplayed: false
    });

    _defineProperty(_assertThisInitialized(_this), "handleGridReady", function (params) {
      _this.gridApi = params.api;
      _this.gridColumnApi = params.columnApi;
    });

    _defineProperty(_assertThisInitialized(_this), "handleRowChange", function (event) {
      var onChange = _this.props.onChange;
      onChange && onChange(_this.props.value);

      _this.props.builder.withDataObjects(_this.props.value);

      _this.refreshAll();
    });

    _defineProperty(_assertThisInitialized(_this), "handleCellValueChange", function (event) {
      var onChange = _this.props.onChange;
      onChange && onChange(_this.props.value);

      _this.props.builder.withDataObjects(_this.props.value);

      _this.refreshAll();
    });

    _defineProperty(_assertThisInitialized(_this), "handleDeleteRow", function (event, rowIndex) {
      var trimmedData = _lodash["default"].reject(_this.props.value, function (item, index) {
        return index === rowIndex;
      });

      _this.props.onChange(trimmedData);
    });

    _defineProperty(_assertThisInitialized(_this), "handleAddRow", function () {
      _this.props.onChange([].concat(_this.props.value, [{}]));
    });

    _defineProperty(_assertThisInitialized(_this), "refreshAll", function () {
      var params = {
        force: true
      };

      _this.gridApi.refreshCells(params);
    });

    _defineProperty(_assertThisInitialized(_this), "handleToggleDisplayFormula", function (event, value) {
      _this.setState({
        isFormulaDisplayed: event.target.checked
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cellRenderer", function (_ref) {
      var header = _ref.header,
          val = _objectWithoutPropertiesLoose(_ref, ["header"]);

      var computedValue = _this.props.builder.getComputedValue(header.header, val.rowIndex);

      var originalValue = _this.props.builder.getValue(header.header, val.rowIndex);

      var value = _this.state.isFormulaDisplayed ? originalValue : computedValue;

      if (_lodash["default"].isObject(value)) {
        return value.value;
      }

      return value;
    });

    return _this;
  }

  var _proto = ReactAgGridInputTable.prototype;

  _proto.componentDidUpdate = function componentDidUpdate() {
    if (this.gridApi) {
      this.refreshAll();
    }
  };

  _proto.createColumnDefs = function createColumnDefs(headers) {
    var columnDefs = _lodash["default"].map(headers, function (header) {
      var additionalProps = header.readOnly ? {
        cellRenderer: "cellRenderer",
        cellRendererParams: {
          header: header
        }
      } : {};
      return _extends({
        field: header.header,
        editable: !!!header.readOnly
      }, additionalProps);
    });

    return [].concat(columnDefs);
  };

  _proto.resizeColumns = function resizeColumns(params) {
    params.api.sizeColumnsToFit();
  };

  _proto.renderSwitch = function renderSwitch() {
    var isFormulaDisplayed = this.state.isFormulaDisplayed;
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Check, {
      type: "checkbox",
      label: "Check me out",
      className: "custom-control custom-switch"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Check.Input, {
      onChange: this.handleToggleDisplayFormula,
      className: "custom-control-input",
      type: "checkbox",
      id: "customSwitch1",
      checked: isFormulaDisplayed
    }), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Check.Label, {
      className: "custom-control-label",
      "for": "customSwitch1"
    }, "Show Formula"));
  };

  _proto.renderMenuItems = function renderMenuItems() {
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
      className: "align-items-center justify-content-md-end"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      sm: "auto"
    }, this.renderSwitch()), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      sm: "auto"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      onClick: this.handleAddRow,
      variant: "link",
      size: "sm"
    }, "Add Item")));
  };

  _proto.render = function render() {
    var columnDefs = this.createColumnDefs(this.props.headers);
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Container, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ag-theme-alpine",
      style: {
        height: 400,
        width: "100%"
      }
    }, /*#__PURE__*/_react["default"].createElement(_agGridReact.AgGridReact, {
      groupSelectsChildren: true,
      columnDefs: columnDefs,
      rowData: this.props.value,
      gridOptions: {
        onRowValueChanged: this.handleRowChange,
        onCellValueChanged: this.handleCellValueChange,
        components: {
          "cellRenderer": this.cellRenderer
        }
      },
      onFirstDataRendered: this.resizeColumns,
      onGridReady: this.handleGridReady
    }, /*#__PURE__*/_react["default"].createElement(_agGridReact.AgGridColumn, {
      field: "$delete"
    }), _lodash["default"].map(this.props.headers, function (header) {
      return /*#__PURE__*/_react["default"].createElement(_agGridReact.AgGridColumn, {
        field: header.header
      });
    })))), this.renderMenuItems());
  };

  return ReactAgGridInputTable;
}(_react["default"].Component);

var _default = ReactAgGridInputTable;
exports["default"] = _default;
module.exports = exports.default;