"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactBootstrap = require("react-bootstrap");

var _button = _interopRequireDefault(require("./button"));

var _checkbox = _interopRequireDefault(require("./checkbox"));

var _radio = _interopRequireDefault(require("./radio"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactInputTableWidget = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ReactInputTableWidget, _React$Component);

  function ReactInputTableWidget() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      checkbox: true
    });

    return _this;
  }

  var _proto = ReactInputTableWidget.prototype;

  _proto.renderFooterItems = function renderFooterItems() {
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
      className: "align-items-center justify-content-md-end"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      sm: "auto"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "link",
      size: "sm"
    }, "Add Row"), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "link",
      size: "sm"
    }, "Add Column")));
  };

  _proto.renderTable = function renderTable() {
    var _$get = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
        inputTableType = _$get.inputTableType;

    switch (inputTableType) {
      case _constants.CHECKBOX:
        return /*#__PURE__*/_react["default"].createElement(_checkbox["default"], this.props);

      case _constants.RADIO:
        return /*#__PURE__*/_react["default"].createElement(_radio["default"], this.props);

      default:
        return /*#__PURE__*/_react["default"].createElement(_button["default"], this.props);
    }
  };

  _proto.render = function render() {
    var _$get2 = _lodash["default"].get(this.props, "schema", {}),
        title = _$get2.title;

    var _$get3 = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
        headerModifiable = _$get3.headerModifiable,
        columnModifiable = _$get3.columnModifiable;

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), this.renderTable(), headerModifiable && columnModifiable && this.renderFooterItems());
  };

  return ReactInputTableWidget;
}(_react["default"].Component);

var _default = ReactInputTableWidget;
exports["default"] = _default;
module.exports = exports.default;